//#include "testlib.h"

#include <iostream>
#include <math.h>
#include <map>
#include <vector>
#include <stdlib.h>
#include <memory.h>
#include <time.h>
#include <string.h>
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <set>
#include <stack>
#include <cassert>
#include <queue>

using namespace std;

int a[100010];

int main() {
    ios::sync_with_stdio(0);
    int n; cin >> n;
    for(int i = 0; i < n; ++i)
        cin >> a[i];
    long long ans = 0;
    for(int l = 0; l < n && l < 5000; ++l)
        for(int r = max(l+1, n-5000); r < n; ++r)
            ans = max(ans, (r-l)*1ll*min(a[l], a[r]));
    cout << ans << "\n";
    return 0;
}
